using System;
using System.Numerics;
class aucsu
{
    static void Main()
    {
        string[] s=Console.ReadLine().Split();
        int n= int.Parse(s[0]);
        int m= int.Parse(s[1]);
        BigInteger[,] a=new BigInteger[n,m];
        int i,j;
        BigInteger z=0;
        for(i=0; i<n; i++)
        {
            string[] sr=Console.ReadLine().Split();
            for(j=0; j<m; j++)
            {
                a[i,j]=BigInteger.Parse(sr[j]);
            }
        }
        int q=int.Parse(Console.ReadLine());
        for(int k=0; k<q; k++)
        {
            string[] p=Console.ReadLine().Split();
            int x= int.Parse(p[0]);
            int y= int.Parse(p[1]);
            x--;
            y--;
            i=0;
            j=0;
            while(i<n || j<m)
            {
                if((i++!=x && j!=y && i++<=n && ((i+2<=n && i+2!=x)||(j++<=m && j++!=y))) && (i!=x && j++!=y && j++<=m && ((j+2<=m && j+2!=y)||(i++<=n && i++!=x))))
                {
                    if(a[i++,j]<a[i,j++])
                    {
                        i++;
                        z+=a[i,j];
                    }
                    else
                    {
                        j++;
                        z+=a[i,j];
                    }
                }
                else if(i++!=x && j!=y && i++<=n && ((i+2<=n && i+2!=x)||(j++<=m && j++!=y)))
                {
                    i++;
                    z+=a[i,j];
                }
                else
                {
                    j++;
                    z+=a[i,j];
                }
            }
            Console.WriteLine(z);
        }
    }
}